// Generated by CoffeeScript 1.10.0
var CLI, CommandFile, OP, _, cheerio, fs, path,
  extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

CommandFile = (require('commander-file')).CommandFile;

OP = require('object-parser');

cheerio = require('cheerio');

_ = require('lodash');

path = require('path');

fs = require('fs');

CLI = (function(superClass) {
  extend(CLI, superClass);

  function CLI() {
    CLI.__super__.constructor.apply(this, arguments);
    this.config.fileExtension = '.json';
    this.version(require('../package').version);
    this.usage('<file/url> [path/locator...] [options...]');
    this.option('-t, --transform <type>', 'Transform to <json/json5/yaml/html>');
    this.option('-i, --indent <digit>', 'Adjust indents <2>', 2);
    this.option('-s, --separator <string>', 'Change separator (default:" ")', ' ');
  }

  CLI.prototype.getType = function(data) {
    switch (data[0]) {
      case '<':
        return 'html';
      case '[':
        return 'jsonml';
      case '{':
        return 'json5';
      default:
        return 'yaml';
    }
  };

  CLI.prototype.parse = function(argv, reporter) {
    if (reporter == null) {
      reporter = null;
    }
    if (reporter == null) {
      reporter = function(string) {
        return process.stdout.write(string);
      };
    }
    return CLI.__super__.parse.call(this, argv).then((function(_this) {
      return function(data) {
        var dom, filename, object, type, values;
        if (data == null) {
          return _this.help();
        }
        object = _this.parseString(data);
        filename = _this.args.shift();
        if (_this.args.length) {
          type = _this.getType(data);
          data = (function() {
            switch (type) {
              case 'jsonml':
                dom = cheerio.load(OP.stringify('jsonml', data));
                values = this.find(dom, this.args);
                return values.join(this.separator);
              case 'html':
                dom = cheerio.load(data);
                values = this.find(dom, this.args);
                return values.join(this.separator);
              default:
                object = OP.parse(type, data);
                values = this.get(object, this.args);
                return values.join(this.separator);
            }
          }).call(_this);
        } else {
          if (_this.transform == null) {
            _this.transform = 'json';
          }
          data = _this.convert(object, _this.transform, _this.indent);
        }
        return data;
      };
    })(this)).then(reporter);
  };

  CLI.prototype.parseString = function(data) {
    var object, type;
    type = (function() {
      switch (data[0]) {
        case '<':
          return 'jsonml';
        case '[':
          return 'json5';
        case '{':
          return 'json5';
        default:
          return 'yaml';
      }
    })();
    return object = OP.parse(type, data);
  };

  CLI.prototype.convert = function(object, transform, indent) {
    var string;
    transform = (function() {
      switch (transform) {
        case 'html':
          return 'jsonml';
        default:
          return transform;
      }
    })();
    string = OP.stringify(transform, object, null, ~~indent);
    return string;
  };

  CLI.prototype.get = function(object, paths) {
    var i, len, results, value;
    results = [];
    for (i = 0, len = paths.length; i < len; i++) {
      path = paths[i];
      value = _.get(object, path);
      if (value instanceof Array) {
        results.push(value.join(this.separator));
      } else {
        results.push(value);
      }
    }
    return results;
  };

  CLI.prototype.find = function(dom, locators) {
    var attribute, i, len, locator, ref, results, selector;
    results = [];
    for (i = 0, len = locators.length; i < len; i++) {
      locator = locators[i];
      ref = locator.split('?', 2), selector = ref[0], attribute = ref[1];
      if (attribute != null) {
        results.push(dom(selector).eq(0).attr(attribute));
      } else {
        results.push(dom(selector).eq(0).text());
      }
    }
    return results;
  };

  return CLI;

})(CommandFile);

module.exports = new CLI;

module.exports.CLI = CLI;
